// PCDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PCDemo.h"
#include "PCDemoDlg.h"
#include "CommPort.h"
#include "udisk.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPCDemoDlg dialog

CPCDemoDlg::CPCDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPCDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPCDemoDlg)
	m_filename = _T("");
	m_dirname = _T("");
	m_hous = 0;
	m_month = 0;
	m_minute = 0;
	m_offset = 0;
	m_sec = 0;
	m_txt = _T("");
	m_yeah = 0;
	m_edit_txt = _T("");
	m_date = 0;
	m_static_open = _T("");
	m_static_fsize = _T("");
	m_static_disk = _T("");
	m_edit_fsize = 0;
	m_edit_rsize = 0;
	m_changedir = _T("");
	m_deletedir = _T("");
	m_deletefile = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPCDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPCDemoDlg)
	DDX_Control(pDX, IDC_COM_OFFSET, m_comOffset);
	DDX_Control(pDX, IDC_SELCOMM, m_SelComm);
	DDX_Control(pDX, IDC_SELBAUD, m_SelBaud);
	DDX_Text(pDX, IDC_FILENAME, m_filename);
	DDV_MaxChars(pDX, m_filename, 100);
	DDX_Text(pDX, IDC_DIRNAME, m_dirname);
	DDV_MaxChars(pDX, m_dirname, 100);
	DDX_Text(pDX, IDC_H, m_hous);
	DDV_MinMaxByte(pDX, m_hous, 0, 23);
	DDX_Text(pDX, IDC_M, m_month);
	DDV_MinMaxByte(pDX, m_month, 1, 12);
	DDX_Text(pDX, IDC_MINU, m_minute);
	DDV_MinMaxByte(pDX, m_minute, 0, 59);
	DDX_Text(pDX, IDC_OFFSET, m_offset);
	DDX_Text(pDX, IDC_SEC, m_sec);
	DDV_MinMaxByte(pDX, m_sec, 0, 59);
	DDX_Text(pDX, IDC_Y, m_yeah);
	DDV_MinMaxByte(pDX, m_yeah, 0, 99);
	DDX_Text(pDX, IDC_EDIT_TXT, m_edit_txt);
	DDX_Text(pDX, IDC_D, m_date);
	DDV_MinMaxByte(pDX, m_date, 0, 31);
	DDX_Text(pDX, IDC_STATIC_OPEN, m_static_open);
	DDX_Text(pDX, IDC_STATIC_DISK, m_static_disk);
	DDX_Text(pDX, IDC_EDIT_FSIZE, m_edit_fsize);
	DDX_Text(pDX, IDC_EDIT_RSIZE, m_edit_rsize);
	DDX_Text(pDX, IDC_EDIT_ChangeDir, m_changedir);
	DDX_Text(pDX, IDC_EDIT_DELETE_DIR, m_deletedir);
	DDX_Text(pDX, IDC_EDIT_DeleteFile, m_deletefile);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPCDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CPCDemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnOpenFile)
	ON_BN_CLICKED(IDC_BUTTON2, OnWriteFile)
	ON_BN_CLICKED(IDC_BUTTON6, OnOffsetGO)
	ON_CBN_SELCHANGE(IDC_SELCOMM, OnSelchangeSelcomm)
	ON_BN_CLICKED(IDC_BUTTON12, OnButton12)
	ON_BN_CLICKED(IDC_BUTTON4, OnClose)
	ON_BN_CLICKED(IDC_BUTTON5, OnMakeDir)
	ON_BN_CLICKED(IDC_BUTTON8, OnGetSysINF)
	ON_BN_CLICKED(IDC_BUTTON9, OnSetSysInf)
	ON_BN_CLICKED(IDC_BUTTON10, OnWriteTXT)
	ON_BN_CLICKED(IDC_BUTTON11, OnReadTXT)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON7, OnButton_DeleteFile)
	ON_BN_CLICKED(IDC_BUTTON_SetDir, OnBUTTON_SetDir)
	ON_BN_CLICKED(IDC_BUTTON13, OnButton_DeleteDir)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPCDemoDlg message handlers

/* һͨ */
CCommPort Comm;

BOOL CPCDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_SelComm.AddString("1");
	m_SelComm.AddString("2");
	m_SelComm.SetCurSel(0);
	
	m_SelBaud.AddString("4800");	
	m_SelBaud.AddString("9600");
	m_SelBaud.AddString("14400");
	m_SelBaud.AddString("19200");
	m_SelBaud.AddString("38400");
	m_SelBaud.AddString("56000");
	m_SelBaud.AddString("57600");
	m_SelBaud.AddString("115200");
	m_SelBaud.SetCurSel(1);

	m_comOffset.AddString("ʼ");
	m_comOffset.AddString("ӵǰ");
	m_comOffset.AddString("ĩ");
	m_comOffset.SetCurSel(0);
		
	DriverIni();

	m_yeah = 5;
	m_month = 8;
	m_date = 25;
	m_hous = 11;
	m_minute = 12;
	m_sec = 0;
	m_filename ="EasyDisk.TXT";
	m_dirname = "USB_HOST";
	UpdateData(FALSE);

	/*򿪴*/
	int comnum = 0;BOOL bret;
	comnum = m_SelComm.GetCurSel() + 1;
	
	Comm.ClosePort();
	bret = Comm.SetCommPort(comnum);							//ôں
	if (bret == FALSE)
	{
		MessageBox("򿪴ʧ!");
	}

	UINT32 baudtable[8] = {4800,9600, 14400,19200, 38400,56000, 57600, 115200};
	UINT32 baudvalue = baudtable[m_SelBaud.GetCurSel()];
	
	bret = Comm.SetCommBaud(baudvalue);					     //ò		
	if (bret == FALSE)
	{
		MessageBox("òʧ!");
	}

	bret = Comm.OpenPort();									  //򿪴
	if (bret != 0)
	{
		MessageBox("򿪴ʧ!");
	}


//	m_ReadBlock.EnableWindow(FALSE);
//	m_WriteBlock.EnableWindow(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CPCDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPCDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}



// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPCDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

FHANDLE * g_FHandle;

void CPCDemoDlg::OnOpenFile() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	LPCTSTR pCFFileBuff = m_filename;
	UINT FileSize = m_filename.GetLength();

	g_FHandle = FileOpen((char *)pCFFileBuff);
	if(g_FHandle==NULL)
	{	
		MessageBox("豸ڻļѴ򿪣رļԣ");
	}
	else
	{
		m_static_open = "ļѴ򿪣СΪ";
		m_edit_fsize = g_FHandle->fsize;
		UpdateData(FALSE);
	}


}

char * pCFFileBuff;
UINT	CFFileLen;
char  Flag_CF_Open;
void CPCDemoDlg::OnWriteFile() 
{
	// TODO: Add your control notification handler code here
	if(g_FHandle==NULL)
	{	MessageBox("ȴ򿪻򴴽1ļ!");
		return;
	}
	
	
	/* rarļ */
	CFileDialog RarFileDlg(TRUE,
						   "*.*",
						   "*.*",
						   OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,
						   " Files(*.*)|.*||");				
	CFile  RarFile; 
	
	if (RarFileDlg.DoModal() == IDOK)						
	{	
		/* ûѡ *.rar ļ */
		CString FilePathName;
		UINT FileSize;
		
		/* õ *.rar ļ· */
		FilePathName = RarFileDlg.GetPathName();
		RarFile.Open(FilePathName, CFile::modeRead);	/*  */
		
		FileSize = RarFile.SeekToEnd();
		pCFFileBuff = new char[FileSize];				/* ȡļС */		
		
		RarFile.SeekToBegin();
		RarFile.ReadHuge(pCFFileBuff, FileSize);		/* ļ */
		RarFile.Close();
//**********************************************************************

		UINT rtfsize = FileWrite((uint8*)pCFFileBuff,FileSize, g_FHandle);
		if( 0 != rtfsize )	// дļ
		{
			if(FileSize==rtfsize)
				MessageBox("ɹдļ!ȹرļſ԰Ụݿܶʧ");
			else
				MessageBox("δȫд룡");
		}
		else
		{
			MessageBox("дļʧ!");
		}
	}
}

void CPCDemoDlg::OnOffsetGO() 
{
	// TODO: Add your control notification handler code here
		// TODO: Add your control notification handler code here
	UCHAR Whence;
	
	UpdateData(TRUE);
	Whence = m_comOffset.GetCurSel();
	FileSeek(g_FHandle, m_offset, Whence);
}



void CPCDemoDlg::OnEditchangeCombo1() 
{
	// TODO: Add your control notification handler code here
	int i;
	i =0;

}

BOOL OpenCOMM(int comnum,UINT32 baudvalue)
{
	BOOL bret;
	Comm.ClosePort();
	bret = Comm.SetCommPort(comnum);							//ôں
	if (bret == FALSE)
	{
		return FALSE;
	}

	bret = Comm.SetCommBaud(baudvalue);					     //ò		
	if (bret == FALSE)
	{
		return FALSE;
	}

	bret = Comm.OpenPort();									  //򿪴
	if (bret != 0)
	{
		return FALSE;
	}
	return TRUE;
}

void CPCDemoDlg::OnSelchangeSelcomm() 
{
	// TODO: Add your control notification handler code here
		/*򿪴*/
	int comnum = 0;BOOL bret;
	comnum = m_SelComm.GetCurSel() + 1;
	Comm.ClosePort();
	bret = Comm.SetCommPort(comnum);							//ôں
	if (bret == FALSE)
	{
		MessageBox("򿪴ʧ!");
	}

	UINT32 baudtable[8] = {4800,9600, 14400,19200, 38400,56000, 57600, 115200};
	UINT32 baudvalue = baudtable[m_SelBaud.GetCurSel()];
	
	bret = Comm.SetCommBaud(baudvalue);					     //ò		
	if (bret == FALSE)
	{
		MessageBox("òʧ!");
	}

	bret = Comm.OpenPort();									  //򿪴
	if (bret != 0)
	{
		MessageBox("򿪴ʧ!");
	}
}



void CPCDemoDlg::OnButton12() 
{
	// TODO: Add your control notification handler code here
	UINT   readlen;
	BYTE	*Bufptr;
	CFile mFile;

	UpdateData(TRUE);
	LPCTSTR pCFFileBuff = m_filename;

	if(g_FHandle)
	{	
		Bufptr = (BYTE *)malloc(g_FHandle->fsize) ;
		if(Bufptr)
		{	
			readlen = FileRead(Bufptr, g_FHandle->fsize, g_FHandle);
			if(readlen!=0)
			{
				if(readlen == g_FHandle->fsize)
				{
					if(mFile.Open(pCFFileBuff, CFile::modeRead))
					{	mFile.Close(); 
						mFile.Remove(pCFFileBuff);
					}
					mFile.Open(pCFFileBuff, CFile::modeWrite|CFile::modeCreate); 
					mFile.Write(Bufptr,g_FHandle->fsize); 
					mFile.Flush(); 
					mFile.Close(); 
					MessageBox("ļȡɣڸĿ¼");
				}
				else
				{
					MessageBox("ļг!");
				}
			}
			else
			{
				MessageBox("ļȡʧܣ");
			}
		}
		free(Bufptr);
	}
	else
	{
		MessageBox("ѡ򿪻򴴽1ļ!");
	}

}

void CPCDemoDlg::OnClose() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	g_FHandle = NULL;
	FileClose();
	m_static_open = "򿪻򴴽1ļ";
	m_edit_fsize = 0;
	UpdateData(FALSE);
}

void CPCDemoDlg::OnMakeDir() 
{
	// TODO: Add your control notification handler code here
	
	UpdateData(TRUE);
	LPCTSTR pCFFileBuff = m_dirname;
	if( 0 == MakeDir((char*)pCFFileBuff) )
	{
		MessageBox("Ŀ¼ɹ!");
	}
	else
	{
		MessageBox("Ŀ¼ʧ!Ŀ¼Ѵڡ");
	}
}






void CPCDemoDlg::OnGetSysINF() 
{
	// TODO: Add your control notification handler code here
	SYSINF sysinf;
	UINT32 baudtable[8] = {4800,9600, 14400,19200, 38400,56000, 57600, 115200};
	UpdateData(TRUE);
	if(GetDiskInfo(&sysinf))
	{
		MessageBox("豸ɹ!");
		m_SelBaud.SetCurSel(sysinf.Baud);
	//	m_SelComm.SetCurSel(0);
		m_yeah = sysinf.Year;
		m_month = sysinf.Month;
		m_date = sysinf.Dom;
		m_hous = sysinf.Hour;
		m_minute = sysinf.Min;
		m_sec = sysinf.Sec;
		m_edit_fsize =0;
		if(sysinf.DiskIn!=0)
		{
			m_static_disk = "1Uпڡ";
			if(sysinf.FH.fh!=0xFF)
			{
				m_static_open = "Ѵ1ļ";
				m_edit_fsize = sysinf.FH.fsize;
			}
			else
			{
				m_static_open = "/ļ";
			}
		}
		else
		{
			m_static_disk = "Ụ";
		}

		UpdateData(FALSE);
		return;
	}
	MessageBox("ѯCOMںͲ!");
	for(int i=0;i<8;i++)
	{	if(OpenCOMM(1,baudtable[i]))
		{
			if(GetDiskInfo(&sysinf))
			{
				MessageBox("豸ɹ!");
				m_SelBaud.SetCurSel(i);
				m_SelComm.SetCurSel(0);
				m_yeah = sysinf.Year;
				m_month = sysinf.Month;
				m_date = sysinf.Dom;
				m_hous = sysinf.Hour;
				m_minute = sysinf.Min;
				m_sec = sysinf.Sec;
				m_edit_fsize =0;
				if(sysinf.DiskIn!=0)
				{
					m_static_disk = "1Uпڡ";
				}
				else
				{
					m_static_disk = "Ụ";
				}
				if(sysinf.FH.fh!=0xFF)
				{
					m_static_open = "Ѵ1ļ";
					m_edit_fsize = sysinf.FH.fsize;
				}
				else
				{
					m_static_open = "/ļ";
				}
				UpdateData(FALSE);
				return;
			}
		}
		else
			break;
	}

	for(i=0;i<8;i++)
	{	if(OpenCOMM(2,baudtable[i]))
		{
			if(GetDiskInfo(&sysinf))
			{
				MessageBox("豸ɹ!");
				m_SelBaud.SetCurSel(i);
				m_SelComm.SetCurSel(1);
				m_yeah = sysinf.Year;
				m_month = sysinf.Month;
				m_date = sysinf.Dom;
				m_hous = sysinf.Hour;
				m_minute = sysinf.Min;
				m_sec = sysinf.Sec;
				m_edit_fsize =0;
				if(sysinf.DiskIn!=0)
				{
					m_static_disk = "1Uпڡ";
				}
				else
				{
					m_static_disk = "Ụ";
				}
				if(sysinf.FH.fh!=0xFF)
				{
					m_static_open = "Ѵ1ļ";
					m_edit_fsize = sysinf.FH.fsize;
				}
				else
				{
					m_static_open = "/ļ";
				}
				UpdateData(FALSE);
				return;
			}
		}
		else
			break;
	}
	MessageBox("豸ûӦ豸ǷӣڼǷȷ");
}



void CPCDemoDlg::OnSetSysInf() 
{
	// TODO: Add your control notification handler code here
	SYSINF sysinf;
	UpdateData(TRUE);
	sysinf.Baud = m_SelBaud.GetCurSel() ;
	sysinf.Year =m_yeah;
	sysinf.Month = m_month;
	sysinf.Dom = m_date;
	sysinf.Hour = m_hous;
	sysinf.Min = m_minute;
	sysinf.Sec = m_sec;

	if(	SetDiskInfo(&sysinf))
	{
		int comnum = 0;BOOL bret;
		comnum = m_SelComm.GetCurSel() + 1;
		Comm.ClosePort();
		bret = Comm.SetCommPort(comnum);							//ôں
		if (bret == FALSE)
		{
			MessageBox("򿪴ʧ!");
		}

		UINT32 baudtable[8] = {4800,9600, 14400,19200, 38400,56000, 57600, 115200};
		UINT32 baudvalue = baudtable[m_SelBaud.GetCurSel()];
		
		bret = Comm.SetCommBaud(baudvalue);					     //ò		
		if (bret == FALSE)
		{
			MessageBox("òʧ!");
		}

		bret = Comm.OpenPort();									  //򿪴
		if (bret != 0)
		{
			MessageBox("򿪴ʧ!");
		}
		MessageBox("óɹ!ǰѸ¡");
	}
	else
	{
		MessageBox("ʧ!");
	}
}



void CPCDemoDlg::OnWriteTXT() 
{
	// TODO: Add your control notification handler code here
	UINT WriteLen=0; 
	UpdateData(TRUE);
	LPCTSTR pCFFileBuff = m_edit_txt;
	UINT FileSize = m_edit_txt.GetLength();
	if(g_FHandle)
	{	WriteLen = FileWrite((BYTE *)pCFFileBuff, FileSize, g_FHandle);	// дļ
		if(WriteLen)
		{	
			MessageBox("ɹдļ!ȹرļſ԰Ụݿܶʧ");
		}
		else
			MessageBox("дʧܣ");
	}
	else
		MessageBox("ȴ򿪻򴴽1ļ");

}

void CPCDemoDlg::OnReadTXT() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	
	if(g_FHandle)
	{
		BYTE *Bufptr = (BYTE *)malloc(m_edit_rsize+1) ;
		UINT readlen = FileRead(Bufptr, m_edit_rsize, g_FHandle);
		
		if(readlen!=0)
		{
			*(Bufptr+m_edit_rsize) = 0;

			MessageBox("Ѷ");
			m_edit_txt="";
			m_edit_txt = CString(Bufptr);
			
	
			
		}
		else
		{	m_edit_txt="";
			MessageBox("ʧܣݳΪ0");
		}
		UpdateData(FALSE);
		free(Bufptr);
	}
	else
	{
		MessageBox("ȴ򿪻򴴽1ļ");
	}

}
#define SendResponse(buff,len)	Comm.SendData(buff, NULL, len, 10000, 1, 0, FALSE);  //

void CPCDemoDlg::OnButton3() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	LPCTSTR pCFFileBuff = m_changedir;

	if(ChangeDir((char *)pCFFileBuff))
	{	
		MessageBox("õǰĿ¼ʧܣ");
	}
	else
	{
		MessageBox("õǰĿ¼.");
	}
}

void CPCDemoDlg::OnButton_DeleteFile() 
{
	// TODO: Add your control notification handler code here
		UpdateData(TRUE);
	LPCTSTR pCFFileBuff = m_deletefile;

	if(RemoveFile((char *)pCFFileBuff))
	{	
		MessageBox("ɾļʧܣ");
	}
	else
	{
		MessageBox("ɾļ.");
	}
}

void CPCDemoDlg::OnBUTTON_SetDir() 
{
	// TODO: Add your control notification handler code here

}

void CPCDemoDlg::OnButton_DeleteDir() 
{
	// TODO: Add your control notification handler code here
			UpdateData(TRUE);
	LPCTSTR pCFFileBuff = m_deletedir;

	if(RemoveDir((char *)pCFFileBuff))
	{	
		MessageBox("ɾĿ¼ʧܣ");
	}
	else
	{
		MessageBox("ɾĿ¼.");
	}
}
