
#include "stdafx.h"
#include "config.h"
#include "string.h"
#include "udisk.h"
#include "CommPort.h"

#ifndef NULL
#define NULL	0
#endif

#define MAX_FILE_SIZE 	512
#define WAIT_TIME_OUT	0xfffff


FHANDLE	g_handle={0xff,0};


CONTR_DISK	rwdisk;
void SendResponse(uint8 *buff,uint16 len);
extern CCommPort Comm;
#define SendResponse(buff,len)	Comm.SendData(buff, NULL, len, 10000, 1, 0, FALSE);  //
void FreeFHandle(void);
void ReceOneChar(uint8 ReceChar);

/*********************************************************************************************************
** : wait_ack
** : ȴӦ֡
**
** 䡡: 
** 䡡: Ӧ𷵻أTRUEʱأFALSE
********************************************************************************************************/
/*uint8 wait_ack(void)
{
	uint32 i;
	rwdisk.state = 0;

	for(i=0;i<WAIT_TIME_OUT;i++)	// ʱȴ
	{
		if(0xff==rwdisk.state)
			return TRUE;
	}
	return FALSE;
}*/
/*
uint8 wait_ack(void)
{
	uint8	rt = TRUE ,ret,getchar;
	uint32 i;
	rwdisk.state = 0;

	while(0xff!=rwdisk.state)
	{
		for(i=0;i<3;i++)
		{	ret = Comm.ReadBlock(&getchar, 1,200);					   // 
			if(ret==0)
				break;
		}

		if(ret==0)
		{
			i=0;
			ReceOneChar(getchar);
		}
		else
		{
			rt = FALSE;
			break;
		}
	}
	return rt;
}
*/
uint8 wait_ack(void)
{
	uint8	rt = TRUE ,ret;
	uint32 i;
	rwdisk.state = 0;
	uint8 tempbuff[512];
	while(0xff!=rwdisk.state)
	{
		ret = Comm.ReadBlock(tempbuff, 6,2000);					   // 
		if(ret==0)
		{
			for(i=0;i<6;i++)
				ReceOneChar(tempbuff[i]);
		}
		else
		{
			rt = FALSE;
			break;
		}
		
		if(rwdisk.rlen==0)
			break;
		ret = Comm.ReadBlock(tempbuff, rwdisk.rlen,2000);					   // 
		if(ret==0)
		{
			for(i=0; i<rwdisk.rlen; i++)
				ReceOneChar(tempbuff[i]);
		}
		else
		{
			rt = FALSE;
			break;
		}
	}
	return rt;
}

//********************************************************************************************************
// ƣReceOneChar
// ReceCharacter
// 
// һַ
//           Ҫ:յһַú
//********************************************************************************************************
void ReceOneChar(uint8 ReceChar)
{
	static uint8 	HFNumber = 0;
	static uint8	HFBuffer[6];
	static uint16	DataLen;
	static uint8	state=0;

	if(rwdisk.state!=0)
		return;

	switch(state)
	{
		case 0:
			HFBuffer[HFNumber++] = ReceChar;
			if(HFBuffer[0]!='S')				// 
				if( HFNumber == 2 )
					if(HFBuffer[1]!=':')
						HFNumber = 0;
			if( HFNumber == 6 )
			{	HFNumber = 0;
				rwdisk.cmd 	= HFBuffer[2];
				rwdisk.cmds	= HFBuffer[3];
				DataLen = HFBuffer[4] + HFBuffer[5]*0x100;
				rwdisk.rlen = DataLen;
				rwdisk.wlen = 0;
				if(DataLen!=0)
				{
					state = 1;
				}
				else
				{
					rwdisk.state = 0xff;		// ״̬
				}
			}
			break;
		case 1:
			rwdisk.write_ptr[rwdisk.wlen++] = ReceChar;
			if(DataLen==rwdisk.wlen)
			{
				rwdisk.state = 0xff;		// ״̬
				state = 0;
			}
			break;
		default :
            break;
	}
}


void DriverIni(void)
{
   FreeFHandle();				// ļ
   rwdisk.state = 0xff;			// մ
}

/*********************************************************************************************************
** : GetFHandle
** : ȡļ
**
** 䡡: 
** 䡡: 
********************************************************************************************************/
FHANDLE *GetFHandle(void)
{
	if(g_handle.fh==0xff)
		return &g_handle;
	else
		return NULL;
}

/*********************************************************************************************************
** : FreeFHandle
** : ͷļ
**
** 䡡: 
** 䡡: 
********************************************************************************************************/
void FreeFHandle(void)
{
	g_handle.fh = 0xff;
	g_handle.fsize = 0;
}





/*********************************************************************************************************
** : GetDiskInfo
** : ȡϵͳϢ
**
** 䡡: sysinfptr:ϵͳϢݽṹָ
** 䡡: ÷أTRUEأFALSE
********************************************************************************************************/
uint8 GetDiskInfo(SYSINF *sysinfptr)
{
	uint8	reqbuff[14];
	
	reqbuff[0] = 'U';	reqbuff[1]= ':';	reqbuff[2] = 0x00;
	reqbuff[3] = 0;		reqbuff[4] = 0;	reqbuff[5] = 0;
	SendResponse(reqbuff,6);		// ֡
	sysinfptr->DiskIn = 0;			//  U̲
	rwdisk.write_ptr = reqbuff;

	if(wait_ack())					// ȴӦ
	{
		if(rwdisk.cmds==0)
		{	sysinfptr->Baud = reqbuff[0];
			sysinfptr->Year = reqbuff[1];
			sysinfptr->Month= reqbuff[2];
			sysinfptr->Dom = reqbuff[3];
			sysinfptr->Hour = reqbuff[4];
			sysinfptr->Min = reqbuff[5];
			sysinfptr->Sec = reqbuff[6];
				
			sysinfptr->DiskIn= reqbuff[7];
			sysinfptr->FH.fh= reqbuff[8];
			sysinfptr->FH.fsize= reqbuff[9]+
						reqbuff[10]*0x100+
						reqbuff[11]*0x10000+
						reqbuff[12]*0x1000000;
			sysinfptr->version = reqbuff[13];
			return	TRUE;
		}
	}
	
	return	FALSE;
}

/*********************************************************************************************************
** : SetDiskInfo
** : ϵͳϢ
**
** 䡡: sysinfptr:ϵͳϢݽṹָ
** 䡡: ÷أTRUEأFALSE
********************************************************************************************************/
uint8  SetDiskInfo(SYSINF *sysinfptr)
{
	uint8	reqbuff[13];
	reqbuff[0] = 'U';	reqbuff[1]= ':';	reqbuff[2] = 0x01;
	reqbuff[3] = 0;		reqbuff[4] = 7;	reqbuff[5] = 0;
	
	reqbuff[6] = sysinfptr->Baud ;
	reqbuff[7] = sysinfptr->Year ;
	reqbuff[8] = sysinfptr->Month;
	reqbuff[9] = sysinfptr->Dom;
	reqbuff[10] = sysinfptr->Hour;
	reqbuff[11] = sysinfptr->Min;
	reqbuff[12] = sysinfptr->Sec;
				
	SendResponse(reqbuff,13);		// ֡
	
	rwdisk.write_ptr = reqbuff;
	if(wait_ack())// ȴӦ
	{
		if(rwdisk.cmds==0)
		{	
			return	TRUE;
		}
	}
	
	return	FALSE;
}

/*********************************************************************************************************
** : FileOpen
** : ָʽļ
**
** 䡡: DirFileName:ûʹõļ
** 䡡: ļNULLΪܴ
**	   ֵΪļָ
**
********************************************************************************************************/
        FHANDLE *FileOpen(char *DirFileName)
{
	uint8	reqbuff[6];
	uint8	namelen;
	FHANDLE	*handle;
	handle = GetFHandle();
	if(handle==NULL)				// ûпõİ
		return handle;
	reqbuff[0] = 'U';reqbuff[1]= ':';
	reqbuff[2] = 0x10;reqbuff[3] = 0xff;
	namelen = strlen(DirFileName);			// ȡļַ
	reqbuff[4] = namelen; reqbuff[5] = 0;
	
	SendResponse(reqbuff,6);			// ֡
	SendResponse((uint8*)DirFileName,namelen);	// ֡
	
	rwdisk.write_ptr = reqbuff;
	
	if(wait_ack())// ȴӦ
	{
		if(rwdisk.cmds==0)
		{	handle->fh = reqbuff[0];
			handle->fsize = reqbuff[1]+
					reqbuff[2]*0x100+
					reqbuff[3]*0x10000+
					reqbuff[4]*0x1000000;	
		}
		else
			handle = NULL;
	}
	else	
		handle = NULL;
		
	return handle;
}

/*********************************************************************************************************
** : RemoveFile
** : ɾָļ
**
** 䡡: DirFileName:ûʹõļ
** 䡡: Ϊ0ʾɾļ
**	   ֵΪɾļʧ
**
********************************************************************************************************/
uint8 RemoveFile(char *DirFileName)
{
	uint8	reqbuff[6];
	uint8	namelen;
	uint8	ret;
	reqbuff[0] = 'U';reqbuff[1]= ':';
	reqbuff[2] = 0x13;reqbuff[3] = 0xff;
	namelen = strlen(DirFileName);			// ȡļַ
	reqbuff[4] = namelen; reqbuff[5] = 0;
	
	SendResponse(reqbuff,6);			// ֡
	SendResponse((uint8*)DirFileName,namelen);	// ֡
	
	rwdisk.write_ptr = reqbuff;
	
	if(wait_ack())// ȴӦ
	{
		if(rwdisk.cmds==0)
		{	// 
			ret = 0;
		}
		else
			ret = rwdisk.cmds;
	}
	else	
		ret = -1;	// 豸ûӦ
		
	return ret;
}

/*********************************************************************************************************
** : FileClose
** : رָļ
**
** 䡡: Handle:ļ
**
** 䡡: RETURN_OK:ɹ
**        οfat.hйڷֵ˵ 
********************************************************************************************************/
uint8 FileClose(void)
{
	uint8 	reqbuff[6];
	
	reqbuff[0] = 'U';	reqbuff[1]= ':';	reqbuff[2] = 0x12;
	reqbuff[3] = 0;		reqbuff[4] = 0;		reqbuff[5] = 0;
	
	FreeFHandle();
	rwdisk.write_ptr = reqbuff;
	SendResponse(reqbuff,6);		// ֡
	
	if(wait_ack())// ȴӦ
	{
		
		return rwdisk.cmds;
	}
	else
		return	0xf0;				// ûӦ
	
}

/*********************************************************************************************************
** : S_FileWrite
** : дļ
**
** 䡡: Buf:Ҫд
**        Size:Ҫдֽ
**        Handle:ļ
** 䡡: ʵдֽ
********************************************************************************************************/
uint16	S_FileWrite(void *Buf, uint16 Size, FHANDLE *Handle)
{
	uint8	reqbuff[10];
	if(Handle==NULL)	return	0;
	reqbuff[0] = 'U';reqbuff[1]= ':';	reqbuff[2] = 0x20;
	if(Handle->fh!=0xff) reqbuff[3] = Handle->fh;
	else return	0;
	reqbuff[4] = (uint8)Size;
	reqbuff[5] = (uint8)(Size/0x100);
	rwdisk.write_ptr = &reqbuff[6];

	//SendResponse(reqbuff,6);		// ֡
	//SendResponse((uint8*)Buf,Size);		// ֡
	
	uint8	tempbuf[512+6];
	memcpy(tempbuf,reqbuff,6); 
	memcpy(tempbuf+6,Buf,Size); 
	SendResponse(tempbuf,6+Size);

	if(wait_ack())// ȴӦ
	{	if(rwdisk.cmds!=0)
			return 0;
	}
	else	
		return 0;
	return (uint16)(reqbuff[6]+reqbuff[7]*0x100); // reqbuff[8]reqbuff[9]  
}

/*********************************************************************************************************
** : FileWrite
** : дļ
**
** 䡡: Buf:Ҫд
**        Size:Ҫдֽ
**        Handle:ļ
** 䡡: ʵдֽ
********************************************************************************************************/
uint32 FileWrite(uint8 *Buf, uint32 Size, FHANDLE *Handle)
{
	uint32	allwrite=0;
	uint16  bewrite;
	
	while((Size/MAX_FILE_SIZE)>0)
	{
		Size -= MAX_FILE_SIZE;
		bewrite = S_FileWrite( Buf+allwrite,MAX_FILE_SIZE,Handle);
		if(bewrite == MAX_FILE_SIZE)
		{
			allwrite += bewrite;
		}
		else	// дļ
		{
			return allwrite;
		}
	}

	bewrite = 0;
	if(Size)
	{
		bewrite = S_FileWrite(Buf+allwrite,(uint16) Size,Handle);
	}

	return allwrite+bewrite;
}

/*********************************************************************************************************
** : FileRead
** : ȡļ
**
** 䡡: Buf:ص
**        Size:Ҫֽ
**        Handle:ļ
** 䡡: ʵʶֽ
********************************************************************************************************/
uint16 S_FileRead(void *Buf, uint16 Size, FHANDLE *Handle)
{
	uint8	reqbuff[10];
	if(Handle==NULL)	return	0;
	reqbuff[0] = 'U';reqbuff[1]= ':';	reqbuff[2] = 0x30;
	if(Handle->fh!=0xff) reqbuff[3] = Handle->fh;
	else return	0;
	reqbuff[4] = 4;
	reqbuff[5] = 0;
	reqbuff[6] = (uint8)Size;
	reqbuff[7] = (uint8)(Size/0x100);
	reqbuff[8] = 0;
	reqbuff[9] = 0;
	
	rwdisk.write_ptr = (uint8*)Buf;
	SendResponse(reqbuff,10);		// ֡

	
	if(wait_ack())// ȴӦ
	{	if(rwdisk.cmds!=0)
			return 0;
	}
	else	return 0;
	return (uint16)rwdisk.wlen;
}

/*********************************************************************************************************
** : FileRead
** : ȡļ
**
** 䡡: Buf:ص
**        Size:Ҫֽ
**        Handle:ļ
** 䡡: ʵʶֽ
********************************************************************************************************/
uint32 FileRead(uint8 *Buf, uint32 Size, FHANDLE *Handle)
{
	uint32	allread=0;
	uint16  beread;
	
	while((Size/MAX_FILE_SIZE)>0)
	{
		Size -= MAX_FILE_SIZE;
		beread = S_FileRead( Buf+allread,MAX_FILE_SIZE,Handle);
		if(beread==MAX_FILE_SIZE)
		{
			allread += beread;
		}
		else	// дļ
		{
			return allread;
		}
	}
	beread = 0;
	if(Size)
	{
		beread = S_FileRead(Buf+allread,(uint16) Size,Handle);
	}
	return allread+beread;
}



/*********************************************************************************************************
** : FileSeek
** : ƶļ\дλ
**
** 䡡: Handle:ļ
**        offset:ƶƫ
**        Whence:ƶģʽSEEK_SET:ļͷSEEK_CUR:ӵǰλüSEEK_END:ļβ
** 䡡: ɹ0
**         ط0ֵ
********************************************************************************************************/
uint8 FileSeek(FHANDLE *Handle, int32 offset, uint8 Whence)
{
	uint8	reqbuff[11];
	if(Handle==NULL)	return	PARAMETER_ERR;
	reqbuff[0] = 'U';	reqbuff[1]= ':';	reqbuff[2] = 0x40;
	if(Handle->fh!=0xff) 
		reqbuff[3] = Handle->fh;
	else 
		return	PARAMETER_ERR;
	reqbuff[4] = 5;
	reqbuff[5] = 0;
	
	reqbuff[6] = offset & 0xff;
	reqbuff[7] = (offset>>8) & 0xff ;
	reqbuff[8] = (offset>>16) & 0xff;
	reqbuff[9] = (offset>>24) & 0xff;
	
	reqbuff[10] = Whence;

	rwdisk.write_ptr = reqbuff;
	SendResponse(reqbuff,11);		// ֡
	
	if(wait_ack())// ȴӦ
	{	
		return rwdisk.cmds;
	}
	else	
		return 0xff;
}

/*********************************************************************************************************
** : MakeDir
** : Ŀ¼
**
** 䡡: Path:·
**
** 䡡: ɹ0
**         ط0ֵ
********************************************************************************************************/
uint8 MakeDir(char *Path)
{
	uint8	reqbuff[6];
	uint8	namelen;
	uint8	rt;

	reqbuff[0] = 'U';reqbuff[1]= ':';
	reqbuff[2] = 0x50;reqbuff[3] = 0xff;
	namelen = strlen(Path);					// ȡļַ
	reqbuff[4] = namelen; reqbuff[5] = 0;
	
	SendResponse(reqbuff,6);				// ֡
	SendResponse((uint8*)Path,namelen);		// ֡
	
	rwdisk.write_ptr = reqbuff;
	
	if(wait_ack())							// ȴӦ
	{
		rt = rwdisk.cmds;
	}
	else	
		rt = 0xff;
		
	return rt;
}

/*********************************************************************************************************
** : RemoveDir
** : õǰĿ¼
**
** 䡡: DirFileNameĿ¼·
** 䡡: Ϊ0ʾ
**			ֵΪʧ
**
********************************************************************************************************/
uint8 ChangeDir(char *DirFileName)
{
	uint8	reqbuff[6];
	uint8	namelen;
	uint8	ret;
	reqbuff[0] = 'U';reqbuff[1]= ':';
	reqbuff[2] = 0x52;reqbuff[3] = 0x00;
	namelen = strlen(DirFileName);			// ȡļַ
	reqbuff[4] = namelen; reqbuff[5] = 0;
	
	SendResponse(reqbuff,6);			// ֡
	SendResponse((uint8*)DirFileName,namelen);	// ֡
	
	rwdisk.write_ptr = reqbuff;
	
	if(wait_ack())// ȴӦ
	{
		if(rwdisk.cmds==0)
		{	// 
			ret = 0;
		}
		else
			ret = rwdisk.cmds;
	}
	else	
		ret = -1;	// 豸ûӦ
		
	return ret;
}

/*********************************************************************************************************
** : RemoveDir
** : ɾָĿ¼
**
** 䡡: DirFileNameɾĿ¼
** 䡡: Ϊ0ʾɾĿ¼
**			ֵΪɾĿ¼ʧ
**
********************************************************************************************************/
uint8 RemoveDir(char *DirFileName)
{
	uint8	reqbuff[6];
	uint8	namelen;
	uint8	ret;
	reqbuff[0] = 'U';reqbuff[1]= ':';
	reqbuff[2] = 0x53;reqbuff[3] = 0x00;
	namelen = strlen(DirFileName);			// ȡļַ
	reqbuff[4] = namelen; reqbuff[5] = 0;
	
	SendResponse(reqbuff,6);			// ֡
	SendResponse((uint8*)DirFileName,namelen);	// ֡
	
	rwdisk.write_ptr = reqbuff;
	
	if(wait_ack())// ȴӦ
	{
		if(rwdisk.cmds==0)
		{	// 
			ret = 0;
		}
		else
			ret = rwdisk.cmds;
	}
	else	
		ret = -1;	// 豸ûӦ
		
	return ret;
}