#ifndef __UDISK_H
#define __UDISK_H
#include "config.h"

/* ļָʽ */
#define SEEK_SET    0               /* ļʼƶļָ */
#define SEEK_CUR    1               /* ļǰλƶļָ */
#define SEEK_END    2               /* ļβƶļָ */

/* ֵ */
#define RETURN_OK                   0x00    /* ɹ         */
#define NOT_FIND_DISK               0x01    /* ߼̲     */
#define DISK_FULL                   0x02    /* ߼         */
#define SECTOR_NOT_IN_CACHE         0x03    /* ûбcache  */
#define NOT_EMPTY_CACHE             0x04    /* ûпcache    */
#define SECTOR_READ_ERR             0x05    /*        */
#define CLUSTER_NOT_IN_DISK         0x06    /* ߼ûд˴  */
#define NOT_FIND_FDT                0x07    /* ûзļ(Ŀ¼)*/
#define NOT_FAT_DISK                0x08    /* FATļϵͳ    */
#define FDT_OVER                    0x09    /* FDTΧ  */
#define FDT_EXISTS                  0x0a    /* ļ(Ŀ¼)Ѿ*/
#define ROOT_FDT_FULL               0x0b    /* Ŀ¼         */
#define DIR_EMPTY                   0x0C    /* Ŀ¼           */
#define DIR_NOT_EMPTY               0x0d    /* Ŀ¼         */
#define PATH_NOT_FIND               0x0e    /* ·δҵ       */
#define FAT_ERR                     0x0f    /* FAT       */
#define FILE_NAME_ERR               0x10    /* ļ(Ŀ¼) */
#define FILE_EOF                    0x11    /* ļ        */
#define FILE_LOCK                   0x12    /* ļ       */
#define NOT_FIND_FILE               0x13    /* ûзָļ */
#define NOT_FIND_DIR                0x14    /* ûзָĿ¼ */
#define GET_TIME_ERR                0x15    /* ȡʱ */
#define DISK_NO_FORMAT              0x16    /* ߼ûиʽ */
#define NOT_RUN                     0xfd    /* δִ       */
#define BAD_COMMAND                 0xfe    /*        */
#define PARAMETER_ERR               0xff    /* Ƿ        */

typedef struct _F_HANDLE
{
	uint8	fh;
	uint32	fsize;
	
}FHANDLE;

typedef struct __SYSINF{
	uint8	Baud;
	uint8	Year;
	uint8	Month;
	uint8	Dom;
	uint8	Hour;
	uint8	Min;
	uint8	Sec;
	
	uint8	DiskIn;
	FHANDLE	FH;

	uint8	version;
}SYSINF;

typedef struct _CONTR_DISK	
{
	uint8 cmd;				// ָ
	uint8 cmds;				// ļ
	
//	uint32 offset;			// ָתƫ
	
	char 	*fname;			// ļ·
	
//	uint8	*read_ptr;		// ݻָ
	uint32 	rlen;			// ݳ
	uint8	*write_ptr;		// дݻָ
	uint32 	wlen;			// дݳ
	
	
 volatile	uint8	state;			// ״̬
}CONTR_DISK;


void	DriverIni(void);
uint8  GetDiskInfo(SYSINF *sysinfptr);
uint8  SetDiskInfo(SYSINF *sysinfptr);
FHANDLE *FileOpen(char *DirFileName);
uint8 FileClose(void);
uint32 FileWrite(uint8 *Buf, uint32 Size, FHANDLE *Handle);
uint32 FileRead(uint8 *Buf, uint32 Size, FHANDLE *Handle);
uint8 MakeDir(char *Path);
uint8 FileSeek(FHANDLE *Handle, int32 offset, uint8 Whence);

uint8 RemoveFile(char *DirFileName);
uint8 RemoveDir(char *DirFileName);
uint8 ChangeDir(char *DirFileName);
#endif